<?php

namespace NoccyLabs\FreshDocker\Configuration;

use Symfony\Component\Yaml\Yaml;

class ComposeConfiguration
{

    private array $checks = [];

    public function __construct(string $configfile)
    {
        $this->loadComposeFile($configfile);
    }

    private function loadComposeFile($configfile)
    {
        $config = Yaml::parseFile($configfile);
        $services = $config['services']??[];
        foreach ($services as $name=>$service) {
            $image = $service['image']??null;
            if ($image && !in_array($image,$this->checks)) {
                $this->checks[] = $image;
            }
        }
    }

    public function getChecks(): array
    {
        return $this->checks;
    }
}